【C】153 寻找旋转排序数组中的最小值

已知一个长度为 n 的数组,预先按照升序排列,经由 1 到 n 次 旋转 后,得到输入数组。例如,原数组 nums = 0,1,2,4,5,6,7 在变化后可能得到:

若旋转 4 次,则可以得到 4,5,6,7,0,1,2

若旋转 7 次,则可以得到 0,1,2,4,5,6,7

注意,数组 a\[0, a1, a2, ..., an-1] 旋转一次 的结果为数组 a\[n-1, a0, a1, a2, ..., an-2] 。

给你一个元素值 互不相同 的数组 nums ,它原来是一个升序排列的数组,并按上述情形进行了多次旋转。请你找出并返回数组中的 最小元素 。

你必须设计一个时间复杂度为 O(log n) 的算法解决此问题。

c 复制代码
#include <stdio.h>

int findMin(int* nums, int numsSize) {
    int left = 0, right = numsSize - 1;
    
    while (left < right) {
        int mid = left + (right - left) / 2;
        
        if (nums[mid] > nums[right]) {
            left = mid + 1;
        } else {
            right = mid;
        }
    }
    
    return nums[left];
}

int main() {
    int nums[] = {4, 5, 6, 7, 0, 1, 2};
    int numsSize = sizeof(nums) / sizeof(nums[0]);
    
    int min = findMin(nums, numsSize);
    printf("最小元素为: %d\n", min);
    
    return 0;
}

总体思路,通过判断当前中间元素 numsmid 和最右侧元素 numsright 的大小关系,以确定最小元素的位置所在。

如果 numsmid > numsright:

这表示当前中间元素 numsmid 大于最右侧元素 numsright,说明最小元素位于 mid 的右侧(包括 mid 自身)。因此,将搜索范围调整到 mid + 1, right,即将 left 指针移到 mid + 1 处。

否则:

如果 numsmid <= numsright,则说明最小元素位于 left 到 mid 之间(包括 mid)。因此,将搜索范围调整到 left, mid,即将 right 指针移到 mid 处。

通过这样的判断和调整,不断缩小搜索范围,直到 left 和 right 指针相遇,找到最小元素的位置。

利用二分查找的思想,每次通过比较中间元素与右边界元素的大小关系,将搜索范围缩小一半,因此时间复杂度为 O(log n)。

这种算法充分利用了数组原本是升序排列的性质,并通过比较中间元素与右侧边界元素的大小关系,快速缩小搜索范围,从而找到最小值的位置。

相关推荐
曦樂~8 小时前
Cpp面筋
c语言·c++
Dream it possible!11 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊11 小时前
算法之双指针系列(一)
算法·leetcode
十二11 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯
小此方12 小时前
[算法实战论:动态规划]回文串问题的dp解法,回文串问题的母题,以及以此为基础的派生题
算法·动态规划
Pniubi13 小时前
力扣560.和为k的子数组
算法·leetcode·职场和发展
D e re k ZH13 小时前
C++ 从零入门(一):基础语法与程序结构
数据结构·c++·算法
Pniubi14 小时前
力扣438.找到字符串中所有字母异位词
算法·leetcode·职场和发展
東隅已逝,桑榆非晚16 小时前
算法6. 双指针法-查找总价格为目标的两个商品
c++·学习·算法
Eyfcom17 小时前
〖物联网终端实战 01〗UWB 室内高精度定位:仓储 AGV 与人员的厘米级轨迹追踪
物联网·算法·物流系统·快递系统·跨境物流快递系统·物联网终端实战